Index: uspace/drv/char/pl011/pl011.c
===================================================================
--- uspace/drv/char/pl011/pl011.c	(revision b781cc497418aafed520d245eab50c6954c84dcd)
+++ uspace/drv/char/pl011/pl011.c	(revision b781cc497418aafed520d245eab50c6954c84dcd)
@@ -0,0 +1,382 @@
+/*
+ * Copyright (c) 2016 Petr Pavlu
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @file ARM PrimeCell PL011 UART driver.
+ */
+
+#include <async.h>
+#include <ddf/driver.h>
+#include <ddf/log.h>
+#include <ddi.h>
+#include <errno.h>
+#include <io/chardev_srv.h>
+#include <macros.h>
+
+#include "pl011.h"
+
+/** PL011 register map. */
+typedef struct {
+	/** UART data register. */
+	ioport32_t data;
+	union {
+		/** Receive status register (same values that are in upper bits
+		 * of data register).
+		 */
+		const ioport32_t status;
+		/** Error clear register (writing anything clears all errors).
+		 */
+		ioport32_t error_clear;
+	};
+	/** Reserved. */
+	PADD32(4);
+	/** Flag register. */
+	const ioport32_t flag;
+	/** Transmit FIFO full. */
+#define PL011_UART_FLAG_TXFF_FLAG  (1 << 5)
+
+	/** Reserved. */
+	PADD32(1);
+	/** IrDA low-power counter register. */
+	ioport32_t irda_low_power;
+	/** Integer baud rate register. */
+	ioport32_t int_baud_divisor;
+	/** Fractional baud rate register. */
+	ioport32_t fract_baud_divisor;
+	/** Line control register. */
+	ioport32_t line_control_high;
+	/** Control register. */
+	ioport32_t control;
+	/** Interrupt FIFO level select register. */
+	ioport32_t interrupt_fifo;
+	/** Interrupt mask set/clear register. */
+	ioport32_t interrupt_mask;
+	/** Raw interrupt status register (pending interrupts before applying
+	 * the mask).
+	 */
+	const ioport32_t raw_interrupt_status;
+	/** Masked interrupt status register (pending interrupts after applying
+	 * the mask).
+	 */
+	const ioport32_t masked_interrupt_status;
+	/** Interrupt clear register (write 1s to clear pending interrupts). */
+	ioport32_t interrupt_clear;
+
+	/** Interrupt indicating a change in the nUARTRI modem status. */
+#define PL011_UART_INTERRUPT_RIM_FLAG   (1 << 0)
+	/** Interrupt indicating a change in the nUARTCTS modem status. */
+#define PL011_UART_INTERRUPT_CTSM_FLAG  (1 << 1)
+	/** Interrupt indicating a change in the nUARTDCD modem status. */
+#define PL011_UART_INTERRUPT_DCDM_FLAG  (1 << 2)
+	/** Interrupt indicating a change in the nUARTDSR modem status. */
+#define PL011_UART_INTERRUPT_DSRM_FLAG  (1 << 3)
+	/** The receive interrupt. */
+#define PL011_UART_INTERRUPT_RX_FLAG    (1 << 4)
+	/** The transmit interrupt. */
+#define PL011_UART_INTERRUPT_TX_FLAG    (1 << 5)
+	/** The receive timeout interrupt.  */
+#define PL011_UART_INTERRUPT_RT_FLAG    (1 << 6)
+	/** Interrupt indicating an overrun error. */
+#define PL011_UART_INTERRUPT_FE_FLAG    (1 << 7)
+	/** Interrupt indicating a break in the reception. */
+#define PL011_UART_INTERRUPT_PE_FLAG    (1 << 8)
+	/** Interrupt indicating a parity error in the received character. */
+#define PL011_UART_INTERRUPT_BE_FLAG    (1 << 9)
+	/** Interrupt indicating a framing error in the received character. */
+#define PL011_UART_INTERRUPT_OE_FLAG    (1 << 10)
+	/** All interrupt mask. */
+#define PL011_UART_INTERRUPT_ALL        0x3ff
+
+	/** DMA control register. */
+	ioport32_t dma_control;
+	/** Reserved. */
+	PADD32(13);
+	/** Reserved for test purposes. */
+	PADD32(4);
+	/** Reserved. */
+	PADD32(976);
+	/** Reserved for future ID expansion. */
+	PADD32(4);
+	/** UARTPeriphID0 register. */
+	const ioport32_t periph_id0;
+	/** UARTPeriphID1 register. */
+	const ioport32_t periph_id1;
+	/** UARTPeriphID2 register. */
+	const ioport32_t periph_id2;
+	/** UARTPeriphID3 register. */
+	const ioport32_t periph_id3;
+	/** UARTPCellID0 register. */
+	const ioport32_t cell_id0;
+	/** UARTPCellID1 register. */
+	const ioport32_t cell_id1;
+	/** UARTPCellID2 register. */
+	const ioport32_t cell_id2;
+	/** UARTPCellID3 register. */
+	const ioport32_t cell_id3;
+} pl011_uart_regs_t;
+
+static void pl011_connection(ipc_call_t *, void *);
+
+static errno_t pl011_read(chardev_srv_t *, void *, size_t, size_t *,
+    chardev_flags_t);
+static errno_t pl011_write(chardev_srv_t *, const void *, size_t, size_t *);
+
+static chardev_ops_t pl011_chardev_ops = {
+	.read = pl011_read,
+	.write = pl011_write
+};
+
+/** Address range accessed by the PL011 interrupt pseudo-code. */
+static const irq_pio_range_t pl011_ranges_proto[] = {
+	{
+		.base = 0,
+		.size = sizeof(pl011_uart_regs_t)
+	}
+};
+
+/** PL011 interrupt pseudo-code instructions. */
+static const irq_cmd_t pl011_cmds_proto[] = {
+	{
+		/* Read masked_interrupt_status. */
+		.cmd = CMD_PIO_READ_32,
+		.addr = NULL,
+		.dstarg = 1
+	},
+	{
+		.cmd = CMD_AND,
+		.value = PL011_UART_INTERRUPT_RX_FLAG |
+		    PL011_UART_INTERRUPT_RT_FLAG,
+		.srcarg = 1,
+		.dstarg = 3
+	},
+	{
+		.cmd = CMD_PREDICATE,
+		.value = 1,
+		.srcarg = 3
+	},
+	{
+		/* Read data. */
+		.cmd = CMD_PIO_READ_32,
+		.addr = NULL,
+		.dstarg = 2
+	},
+	{
+		.cmd = CMD_ACCEPT
+	}
+};
+
+/** Process an interrupt from a PL011 device. */
+static void pl011_irq_handler(ipc_call_t *call, void *arg)
+{
+	pl011_t *pl011 = (pl011_t *) arg;
+	uint32_t intrs = ipc_get_arg1(call);
+	uint8_t c = ipc_get_arg2(call);
+	errno_t rc;
+
+	if ((intrs & (PL011_UART_INTERRUPT_RX_FLAG |
+	    PL011_UART_INTERRUPT_RT_FLAG)) == 0) {
+		/* TODO */
+		return;
+	}
+
+	fibril_mutex_lock(&pl011->buf_lock);
+
+	rc = circ_buf_push(&pl011->cbuf, &c);
+	if (rc != EOK)
+		ddf_msg(LVL_ERROR, "Buffer overrun");
+
+	fibril_mutex_unlock(&pl011->buf_lock);
+	fibril_condvar_broadcast(&pl011->buf_cv);
+}
+
+/** Add a PL011 device. */
+errno_t pl011_add(pl011_t *pl011, pl011_res_t *res)
+{
+	ddf_fun_t *fun = NULL;
+	irq_pio_range_t *pl011_ranges = NULL;
+	irq_cmd_t *pl011_cmds = NULL;
+	errno_t rc;
+
+	circ_buf_init(&pl011->cbuf, pl011->buf, pl011_buf_size, 1);
+	fibril_mutex_initialize(&pl011->buf_lock);
+	fibril_condvar_initialize(&pl011->buf_cv);
+
+	pl011->irq_handle = CAP_NIL;
+
+	pl011_ranges = malloc(sizeof(pl011_ranges_proto));
+	if (pl011_ranges == NULL) {
+		rc = ENOMEM;
+		goto error;
+	}
+	pl011_cmds = malloc(sizeof(pl011_cmds_proto));
+	if (pl011_cmds == NULL) {
+		rc = ENOMEM;
+		goto error;
+	}
+
+	pl011->res = *res;
+
+	fun = ddf_fun_create(pl011->dev, fun_exposed, "a");
+	if (fun == NULL) {
+		ddf_msg(LVL_ERROR, "Error creating function 'a'.");
+		rc = ENOMEM;
+		goto error;
+	}
+
+	rc = pio_enable(
+	    (void *) res->base, sizeof(pl011_uart_regs_t), &pl011->regs);
+	if (rc != EOK)
+		goto error;
+
+	ddf_fun_set_conn_handler(fun, pl011_connection);
+
+	memcpy(pl011_ranges, pl011_ranges_proto, sizeof(pl011_ranges_proto));
+	memcpy(pl011_cmds, pl011_cmds_proto, sizeof(pl011_cmds_proto));
+	pl011_ranges[0].base = res->base;
+	pl011_uart_regs_t *regsphys = (pl011_uart_regs_t *) res->base;
+	pl011_cmds[0].addr = (void *) &regsphys->masked_interrupt_status;
+	pl011_cmds[3].addr = (void *) &regsphys->data;
+
+	pl011->irq_code.rangecount =
+	    sizeof(pl011_ranges_proto) / sizeof(irq_pio_range_t);
+	pl011->irq_code.ranges = pl011_ranges;
+	pl011->irq_code.cmdcount = sizeof(pl011_cmds_proto) / sizeof(irq_cmd_t);
+	pl011->irq_code.cmds = pl011_cmds;
+
+	rc = async_irq_subscribe(res->irq, pl011_irq_handler, pl011,
+	    &pl011->irq_code, &pl011->irq_handle);
+	if (rc != EOK) {
+		ddf_msg(LVL_ERROR, "Error registering IRQ code.");
+		goto error;
+	}
+
+	chardev_srvs_init(&pl011->cds);
+	pl011->cds.ops = &pl011_chardev_ops;
+	pl011->cds.sarg = pl011;
+
+	rc = ddf_fun_bind(fun);
+	if (rc != EOK) {
+		ddf_msg(LVL_ERROR, "Error binding function 'a'.");
+		goto error;
+	}
+
+	ddf_fun_add_to_category(fun, "console");
+
+	return EOK;
+error:
+	if (cap_handle_valid(pl011->irq_handle))
+		async_irq_unsubscribe(pl011->irq_handle);
+	if (fun != NULL)
+		ddf_fun_destroy(fun);
+	free(pl011_ranges);
+	free(pl011_cmds);
+
+	return rc;
+}
+
+/** Remove a PL011 device. */
+errno_t pl011_remove(pl011_t *pl011)
+{
+	return ENOTSUP;
+}
+
+/** A PL011 device gone. */
+errno_t pl011_gone(pl011_t *pl011)
+{
+	return ENOTSUP;
+}
+
+/** Send a character to a PL011 device.
+ *
+ * @param c Character to be printed.
+ */
+static void pl011_putchar(pl011_t *pl011, uint8_t ch)
+{
+	pl011_uart_regs_t *regs = (pl011_uart_regs_t *) pl011->regs;
+
+	/* Wait for space to become available in the TX FIFO. */
+	while (pio_read_32(&regs->flag) & PL011_UART_FLAG_TXFF_FLAG)
+		;
+
+	pio_write_32(&regs->data, ch);
+}
+
+/** Read from a PL011 device. */
+static errno_t pl011_read(chardev_srv_t *srv, void *buf, size_t size,
+    size_t *nread, chardev_flags_t flags)
+{
+	pl011_t *pl011 = (pl011_t *) srv->srvs->sarg;
+	size_t p;
+	uint8_t *bp = (uint8_t *) buf;
+	errno_t rc;
+
+	fibril_mutex_lock(&pl011->buf_lock);
+
+	while ((flags & chardev_f_nonblock) == 0 &&
+	    circ_buf_nused(&pl011->cbuf) == 0)
+		fibril_condvar_wait(&pl011->buf_cv, &pl011->buf_lock);
+
+	p = 0;
+	while (p < size) {
+		rc = circ_buf_pop(&pl011->cbuf, &bp[p]);
+		if (rc != EOK)
+			break;
+		++p;
+	}
+
+	fibril_mutex_unlock(&pl011->buf_lock);
+
+	*nread = p;
+	return EOK;
+}
+
+/** Write to a PL011 device. */
+static errno_t pl011_write(chardev_srv_t *srv, const void *data, size_t size,
+    size_t *nwr)
+{
+	pl011_t *pl011 = (pl011_t *) srv->srvs->sarg;
+	size_t i;
+	uint8_t *dp = (uint8_t *) data;
+
+	for (i = 0; i < size; i++)
+		pl011_putchar(pl011, dp[i]);
+
+	*nwr = size;
+	return EOK;
+}
+
+/** Character device connection handler. */
+static void pl011_connection(ipc_call_t *icall, void *arg)
+{
+	pl011_t *pl011 = (pl011_t *) ddf_dev_data_get(
+	    ddf_fun_get_dev((ddf_fun_t *) arg));
+
+	chardev_conn(icall, &pl011->cds);
+}
+
+/** @}
+ */
Index: uspace/drv/char/pl011/pl011.h
===================================================================
--- uspace/drv/char/pl011/pl011.h	(revision b781cc497418aafed520d245eab50c6954c84dcd)
+++ uspace/drv/char/pl011/pl011.h	(revision b781cc497418aafed520d245eab50c6954c84dcd)
@@ -0,0 +1,78 @@
+/*
+ * Copyright (c) 2018 Petr Pavlu
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup uspace_drv_pl011
+ * @{
+ */
+/** @file
+ */
+
+#ifndef PL011_CON_H
+#define PL011_CON_H
+
+#include <adt/circ_buf.h>
+#include <async.h>
+#include <ddf/driver.h>
+#include <ddi.h>
+#include <fibril_synch.h>
+#include <io/chardev_srv.h>
+#include <loc.h>
+#include <stdint.h>
+
+enum {
+	pl011_buf_size = 64
+};
+
+/** PL011 device resources. */
+typedef struct {
+	uintptr_t base;
+	int irq;
+} pl011_res_t;
+
+/** PL011 device. */
+typedef struct {
+	ddf_dev_t *dev;
+	chardev_srvs_t cds;
+	pl011_res_t res;
+	irq_code_t irq_code;
+	circ_buf_t cbuf;
+	uint8_t buf[pl011_buf_size];
+	fibril_mutex_t buf_lock;
+	fibril_condvar_t buf_cv;
+	void *regs;
+	cap_irq_handle_t irq_handle;
+} pl011_t;
+
+extern errno_t pl011_add(pl011_t *, pl011_res_t *);
+extern errno_t pl011_remove(pl011_t *);
+extern errno_t pl011_gone(pl011_t *);
+
+#endif
+
+/** @}
+ */
Index: uspace/drv/char/pl011/pl011.ma
===================================================================
--- uspace/drv/char/pl011/pl011.ma	(revision b781cc497418aafed520d245eab50c6954c84dcd)
+++ uspace/drv/char/pl011/pl011.ma	(revision b781cc497418aafed520d245eab50c6954c84dcd)
@@ -0,0 +1,1 @@
+10 arm/pl011
Index: uspace/drv/char/pl050/pl050.c
===================================================================
--- uspace/drv/char/pl050/pl050.c	(revision 46288eef683d4b03bcbb084da70081298922bd22)
+++ uspace/drv/char/pl050/pl050.c	(revision b781cc497418aafed520d245eab50c6954c84dcd)
@@ -157,5 +157,5 @@
 	}
 
-	pl050->buffer[pl050->buf_wp] = IPC_GET_ARG2(*call);
+	pl050->buffer[pl050->buf_wp] = ipc_get_arg2(call);
 	pl050->buf_wp = nidx;
 	fibril_condvar_broadcast(&pl050->buf_cv);
Index: uspace/drv/hid/adb-kbd/adb-kbd.c
===================================================================
--- uspace/drv/hid/adb-kbd/adb-kbd.c	(revision 46288eef683d4b03bcbb084da70081298922bd22)
+++ uspace/drv/hid/adb-kbd/adb-kbd.c	(revision b781cc497418aafed520d245eab50c6954c84dcd)
@@ -141,12 +141,12 @@
 		errno_t retval = EOK;
 
-		if (!IPC_GET_IMETHOD(call)) {
+		if (!ipc_get_imethod(&call)) {
 			async_answer_0(&call, EOK);
 			return;
 		}
 
-		switch (IPC_GET_IMETHOD(call)) {
+		switch (ipc_get_imethod(&call)) {
 		case ADB_REG_NOTIF:
-			adb_kbd_reg0_data(kbd, IPC_GET_ARG1(call));
+			adb_kbd_reg0_data(kbd, ipc_get_arg1(&call));
 			break;
 		default:
@@ -205,5 +205,5 @@
 	while (true) {
 		async_get_call(&call);
-		method = IPC_GET_IMETHOD(call);
+		method = ipc_get_imethod(&call);
 
 		if (!method) {
Index: uspace/drv/hid/adb-mouse/adb-mouse.c
===================================================================
--- uspace/drv/hid/adb-mouse/adb-mouse.c	(revision 46288eef683d4b03bcbb084da70081298922bd22)
+++ uspace/drv/hid/adb-mouse/adb-mouse.c	(revision b781cc497418aafed520d245eab50c6954c84dcd)
@@ -99,12 +99,12 @@
 		errno_t retval = EOK;
 
-		if (!IPC_GET_IMETHOD(call)) {
+		if (!ipc_get_imethod(&call)) {
 			/* TODO: Handle hangup */
 			return;
 		}
 
-		switch (IPC_GET_IMETHOD(call)) {
+		switch (ipc_get_imethod(&call)) {
 		case ADB_REG_NOTIF:
-			adb_mouse_data(mouse, IPC_GET_ARG1(call));
+			adb_mouse_data(mouse, ipc_get_arg1(&call));
 			break;
 		default:
@@ -215,5 +215,5 @@
 	while (true) {
 		async_get_call(&call);
-		method = IPC_GET_IMETHOD(call);
+		method = ipc_get_imethod(&call);
 
 		if (!method) {
Index: uspace/drv/hid/atkbd/atkbd.c
===================================================================
--- uspace/drv/hid/atkbd/atkbd.c	(revision 46288eef683d4b03bcbb084da70081298922bd22)
+++ uspace/drv/hid/atkbd/atkbd.c	(revision b781cc497418aafed520d245eab50c6954c84dcd)
@@ -310,5 +310,5 @@
 static void default_connection_handler(ddf_fun_t *fun, ipc_call_t *icall)
 {
-	const sysarg_t method = IPC_GET_IMETHOD(*icall);
+	const sysarg_t method = ipc_get_imethod(icall);
 	at_kbd_t *kbd = ddf_dev_data_get(ddf_fun_get_dev(fun));
 	async_sess_t *sess;
Index: uspace/drv/hid/ps2mouse/ps2mouse.c
===================================================================
--- uspace/drv/hid/ps2mouse/ps2mouse.c	(revision 46288eef683d4b03bcbb084da70081298922bd22)
+++ uspace/drv/hid/ps2mouse/ps2mouse.c	(revision b781cc497418aafed520d245eab50c6954c84dcd)
@@ -429,5 +429,5 @@
 void default_connection_handler(ddf_fun_t *fun, ipc_call_t *icall)
 {
-	const sysarg_t method = IPC_GET_IMETHOD(*icall);
+	const sysarg_t method = ipc_get_imethod(icall);
 	ps2_mouse_t *mouse = ddf_dev_data_get(ddf_fun_get_dev(fun));
 	async_sess_t *sess;
Index: uspace/drv/hid/usbhid/kbd/kbddev.c
===================================================================
--- uspace/drv/hid/usbhid/kbd/kbddev.c	(revision 46288eef683d4b03bcbb084da70081298922bd22)
+++ uspace/drv/hid/usbhid/kbd/kbddev.c	(revision b781cc497418aafed520d245eab50c6954c84dcd)
@@ -159,5 +159,5 @@
 static void default_connection_handler(ddf_fun_t *fun, ipc_call_t *icall)
 {
-	const sysarg_t method = IPC_GET_IMETHOD(*icall);
+	const sysarg_t method = ipc_get_imethod(icall);
 	usb_kbd_t *kbd_dev = ddf_fun_data_get(fun);
 	async_sess_t *sess;
@@ -165,5 +165,5 @@
 	switch (method) {
 	case KBDEV_SET_IND:
-		kbd_dev->mods = IPC_GET_ARG1(*icall);
+		kbd_dev->mods = ipc_get_arg1(icall);
 		usb_kbd_set_led(kbd_dev->hid_dev, kbd_dev);
 		async_answer_0(icall, EOK);
Index: uspace/drv/hid/xtkbd/xtkbd.c
===================================================================
--- uspace/drv/hid/xtkbd/xtkbd.c	(revision 46288eef683d4b03bcbb084da70081298922bd22)
+++ uspace/drv/hid/xtkbd/xtkbd.c	(revision b781cc497418aafed520d245eab50c6954c84dcd)
@@ -344,5 +344,5 @@
 static void default_connection_handler(ddf_fun_t *fun, ipc_call_t *icall)
 {
-	const sysarg_t method = IPC_GET_IMETHOD(*icall);
+	const sysarg_t method = ipc_get_imethod(icall);
 	xt_kbd_t *kbd = ddf_dev_data_get(ddf_fun_get_dev(fun));
 	unsigned mods;
@@ -355,5 +355,5 @@
 		 * assume AT keyboard with Scan Code Set 1.
 		 */
-		mods = IPC_GET_ARG1(*icall);
+		mods = ipc_get_arg1(icall);
 		const uint8_t status = 0 |
 		    ((mods & KM_CAPS_LOCK) ? LI_CAPS : 0) |
Index: uspace/drv/intctl/apic/apic.c
===================================================================
--- uspace/drv/intctl/apic/apic.c	(revision 46288eef683d4b03bcbb084da70081298922bd22)
+++ uspace/drv/intctl/apic/apic.c	(revision b781cc497418aafed520d245eab50c6954c84dcd)
@@ -179,5 +179,5 @@
 		async_get_call(&call);
 
-		if (!IPC_GET_IMETHOD(call)) {
+		if (!ipc_get_imethod(&call)) {
 			/* The other side has hung up. */
 			async_answer_0(&call, EOK);
@@ -185,8 +185,8 @@
 		}
 
-		switch (IPC_GET_IMETHOD(call)) {
+		switch (ipc_get_imethod(&call)) {
 		case IRC_ENABLE_INTERRUPT:
 			async_answer_0(&call, apic_enable_irq(apic,
-			    IPC_GET_ARG1(call)));
+			    ipc_get_arg1(&call)));
 			break;
 		case IRC_DISABLE_INTERRUPT:
Index: uspace/drv/intctl/gicv2/Makefile
===================================================================
--- uspace/drv/intctl/gicv2/Makefile	(revision b781cc497418aafed520d245eab50c6954c84dcd)
+++ uspace/drv/intctl/gicv2/Makefile	(revision b781cc497418aafed520d245eab50c6954c84dcd)
@@ -0,0 +1,37 @@
+#
+# Copyright (c) 2016 Petr Pavlu
+# All rights reserved.
+#
+# Redistribution and use in source and binary forms, with or without
+# modification, are permitted provided that the following conditions
+# are met:
+#
+# - Redistributions of source code must retain the above copyright
+#   notice, this list of conditions and the following disclaimer.
+# - Redistributions in binary form must reproduce the above copyright
+#   notice, this list of conditions and the following disclaimer in the
+#   documentation and/or other materials provided with the distribution.
+# - The name of the author may not be used to endorse or promote products
+#   derived from this software without specific prior written permission.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+# IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+# OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+# IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+# INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+# NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+# THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+#
+
+USPACE_PREFIX = ../../..
+LIBS = drv
+BINARY = gicv2
+
+SOURCES = \
+	gicv2.c \
+	main.c
+
+include $(USPACE_PREFIX)/Makefile.common
Index: uspace/drv/intctl/gicv2/gicv2.c
===================================================================
--- uspace/drv/intctl/gicv2/gicv2.c	(revision b781cc497418aafed520d245eab50c6954c84dcd)
+++ uspace/drv/intctl/gicv2/gicv2.c	(revision b781cc497418aafed520d245eab50c6954c84dcd)
@@ -0,0 +1,288 @@
+/*
+ * Copyright (c) 2018 Petr Pavlu
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup uspace_drv_gicv2
+ * @{
+ */
+
+/** @file
+ */
+
+#include <async.h>
+#include <bitops.h>
+#include <ddi.h>
+#include <ddf/log.h>
+#include <errno.h>
+#include <macros.h>
+#include <str_error.h>
+#include <ipc/irc.h>
+#include <stdint.h>
+
+#include "gicv2.h"
+
+/** GICv2 distributor register map. */
+typedef struct {
+	/** Distributor control register. */
+	ioport32_t ctlr;
+#define GICV2D_CTLR_ENABLE_FLAG  0x1
+
+	/** Interrupt controller type register. */
+	const ioport32_t typer;
+#define GICV2D_TYPER_IT_LINES_NUMBER_SHIFT  0
+#define GICV2D_TYPER_IT_LINES_NUMBER_MASK \
+	(0x1f << GICV2D_TYPER_IT_LINES_NUMBER_SHIFT)
+
+	/** Distributor implementer identification register. */
+	const ioport32_t iidr;
+	/** Reserved. */
+	PADD32(5);
+	/** Implementation defined registers. */
+	ioport32_t impl[8];
+	/** Reserved. */
+	PADD32(16);
+	/** Interrupt group registers. */
+	ioport32_t igroupr[32];
+	/** Interrupt set-enable registers. */
+	ioport32_t isenabler[32];
+	/** Interrupt clear-enable registers. */
+	ioport32_t icenabler[32];
+	/** Interrupt set-pending registers. */
+	ioport32_t ispendr[32];
+	/** Interrupt clear-pending registers. */
+	ioport32_t icpendr[32];
+	/** GICv2 interrupt set-active registers. */
+	ioport32_t isactiver[32];
+	/** Interrupt clear-active registers. */
+	ioport32_t icactiver[32];
+	/** Interrupt priority registers. */
+	ioport32_t ipriorityr[255];
+	/** Reserved. */
+	PADD32(1);
+	/** Interrupt processor target registers. First 8 words are read-only.
+	 */
+	ioport32_t itargetsr[255];
+	/** Reserved. */
+	PADD32(1);
+	/** Interrupt configuration registers. */
+	ioport32_t icfgr[64];
+	/** Implementation defined registers. */
+	ioport32_t impl2[64];
+	/** Non-secure access control registers. */
+	ioport32_t nsacr[64];
+	/** Software generated interrupt register. */
+	ioport32_t sgir;
+	/** Reserved. */
+	PADD32(3);
+	/** SGI clear-pending registers. */
+	ioport32_t cpendsgir[4];
+	/** SGI set-pending registers. */
+	ioport32_t spendsgir[4];
+	/** Reserved. */
+	PADD32(40);
+	/** Implementation defined identification registers. */
+	const ioport32_t impl3[12];
+} gicv2_distr_regs_t;
+
+/* GICv2 CPU interface register map. */
+typedef struct {
+	/** CPU interface control register. */
+	ioport32_t ctlr;
+#define GICV2C_CTLR_ENABLE_FLAG  0x1
+
+	/** Interrupt priority mask register. */
+	ioport32_t pmr;
+	/** Binary point register. */
+	ioport32_t bpr;
+	/** Interrupt acknowledge register. */
+	const ioport32_t iar;
+#define GICV2C_IAR_INTERRUPT_ID_SHIFT  0
+#define GICV2C_IAR_INTERRUPT_ID_MASK \
+	(0x3ff << GICV2C_IAR_INTERRUPT_ID_SHIFT)
+#define GICV2C_IAR_CPUID_SHIFT  10
+#define GICV2C_IAR_CPUID_MASK \
+	(0x7 << GICV2C_IAR_CPUID_SHIFT)
+
+	/** End of interrupt register. */
+	ioport32_t eoir;
+	/** Running priority register. */
+	const ioport32_t rpr;
+	/** Highest priority pending interrupt register. */
+	const ioport32_t hppir;
+	/** Aliased binary point register. */
+	ioport32_t abpr;
+	/** Aliased interrupt acknowledge register. */
+	const ioport32_t aiar;
+	/** Aliased end of interrupt register. */
+	ioport32_t aeoir;
+	/** Aliased highest priority pending interrupt register. */
+	const ioport32_t ahppir;
+	/** Reserved. */
+	PADD32(5);
+	/** Implementation defined registers. */
+	ioport32_t impl[36];
+	/** Active priorities registers. */
+	ioport32_t apr[4];
+	/** Non-secure active priorities registers. */
+	ioport32_t nsapr[4];
+	/** Reserved. */
+	PADD32(3);
+	/** CPU interface identification register. */
+	const ioport32_t iidr;
+	/** Unallocated. */
+	PADD32(960);
+	/** Deactivate interrupt register. */
+	ioport32_t dir;
+} gicv2_cpui_regs_t;
+
+static errno_t gicv2_enable_irq(gicv2_t *gicv2, sysarg_t irq)
+{
+	if (irq > gicv2->max_irq)
+		return EINVAL;
+
+	ddf_msg(LVL_NOTE, "Enable interrupt '%" PRIun "'.", irq);
+
+	gicv2_distr_regs_t *distr = (gicv2_distr_regs_t *) gicv2->distr;
+	pio_write_32(&distr->isenabler[irq / 32], BIT_V(uint32_t, irq % 32));
+	return EOK;
+}
+
+/** Client connection handler.
+ *
+ * @param icall Call data of the request that opened the connection.
+ * @param arg   Local argument.
+ */
+static void gicv2_connection(ipc_call_t *icall, void *arg)
+{
+	ipc_call_t call;
+	gicv2_t *gicv2;
+
+	/*
+	 * Answer the first IPC_M_CONNECT_ME_TO call.
+	 */
+	async_answer_0(icall, EOK);
+
+	gicv2 = (gicv2_t *)ddf_dev_data_get(ddf_fun_get_dev((ddf_fun_t *)arg));
+
+	while (true) {
+		async_get_call(&call);
+
+		if (!ipc_get_imethod(&call)) {
+			/* The other side has hung up. */
+			async_answer_0(&call, EOK);
+			return;
+		}
+
+		switch (ipc_get_imethod(&call)) {
+		case IRC_ENABLE_INTERRUPT:
+			async_answer_0(&call,
+			    gicv2_enable_irq(gicv2, ipc_get_arg1(&call)));
+			break;
+		case IRC_DISABLE_INTERRUPT:
+			/* XXX TODO */
+			async_answer_0(&call, EOK);
+			break;
+		case IRC_CLEAR_INTERRUPT:
+			/* Noop */
+			async_answer_0(&call, EOK);
+			break;
+		default:
+			async_answer_0(&call, EINVAL);
+			break;
+		}
+	}
+}
+
+/** Add a GICv2 device. */
+errno_t gicv2_add(gicv2_t *gicv2, gicv2_res_t *res)
+{
+	ddf_fun_t *fun_a = NULL;
+	errno_t rc;
+
+	rc = pio_enable((void *) res->distr_base, sizeof(gicv2_distr_regs_t),
+	    &gicv2->distr);
+	if (rc != EOK) {
+		ddf_msg(
+		    LVL_ERROR, "Error enabling PIO for distributor registers.");
+		goto error;
+	}
+
+	rc = pio_enable(
+	    (void *) res->cpui_base, sizeof(gicv2_cpui_regs_t), &gicv2->cpui);
+	if (rc != EOK) {
+		ddf_msg(LVL_ERROR,
+		    "Error enabling PIO for CPU interface registers.");
+		goto error;
+	}
+
+	fun_a = ddf_fun_create(gicv2->dev, fun_exposed, "a");
+	if (fun_a == NULL) {
+		ddf_msg(LVL_ERROR, "Failed creating function 'a'.");
+		rc = ENOMEM;
+		goto error;
+	}
+
+	ddf_fun_set_conn_handler(fun_a, gicv2_connection);
+
+	rc = ddf_fun_bind(fun_a);
+	if (rc != EOK) {
+		ddf_msg(LVL_ERROR, "Failed binding function 'a': %s",
+		    str_error(rc));
+		goto error;
+	}
+
+	rc = ddf_fun_add_to_category(fun_a, "irc");
+	if (rc != EOK)
+		goto error;
+
+	/* Get maximum number of interrupts. */
+	gicv2_distr_regs_t *distr = (gicv2_distr_regs_t *) gicv2->distr;
+	uint32_t typer = pio_read_32(&distr->typer);
+	gicv2->max_irq = (((typer & GICV2D_TYPER_IT_LINES_NUMBER_MASK) >>
+	    GICV2D_TYPER_IT_LINES_NUMBER_SHIFT) + 1) * 32;
+
+	return EOK;
+error:
+	if (fun_a != NULL)
+		ddf_fun_destroy(fun_a);
+	return rc;
+}
+
+/** Remove a GICv2 device. */
+errno_t gicv2_remove(gicv2_t *gicv2)
+{
+	return ENOTSUP;
+}
+
+/** A GICv2 device gone. */
+errno_t gicv2_gone(gicv2_t *gicv2)
+{
+	return ENOTSUP;
+}
+
+/** @}
+ */
